"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _jsonschema = require("jsonschema");

var REQUIRED_FIELD_SYMBOL = "*";

function defaultTypeValue(type) {
  switch (type) {
    case "array":
      return [];
    case "boolean":
      return false;
    case "date-time":
      return "";
    case "number":
      return 0;
    case "object":
      return {};
    case "string":
      return "";
    default:
      return undefined;
  }
}

function defaultFieldValue(formData, schema) {
  if (formData === null) {
    return defaultTypeValue(schema.type);
  }
  if (schema["default"]) {
    return schema["default"];
  }
  return formData;
}

var Field = (function (_React$Component) {
  _inherits(Field, _React$Component);

  function Field() {
    _classCallCheck(this, Field);

    _get(Object.getPrototypeOf(Field.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(Field, [{
    key: "render",
    value: function render() {
      var _props = this.props;
      var type = _props.type;
      var children = _props.children;

      return _react2["default"].createElement(
        "div",
        { className: "field field-" + type },
        _react2["default"].createElement(
          "label",
          null,
          this.label,
          children
        )
      );
    }
  }, {
    key: "label",
    get: function get() {
      var _props2 = this.props;
      var label = _props2.label;
      var required = _props2.required;

      if (!label) {
        return null;
      }
      if (required) {
        return label + REQUIRED_FIELD_SYMBOL;
      }
      return label;
    }
  }]);

  return Field;
})(_react2["default"].Component);

var TextField = (function (_React$Component2) {
  _inherits(TextField, _React$Component2);

  function TextField() {
    _classCallCheck(this, TextField);

    _get(Object.getPrototypeOf(TextField.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(TextField, [{
    key: "onChange",
    value: function onChange(event) {
      this.props.onChange(event.target.value);
    }
  }, {
    key: "render",
    value: function render() {
      var _props3 = this.props;
      var schema = _props3.schema;
      var formData = _props3.formData;
      var label = _props3.label;
      var required = _props3.required;
      var placeholder = _props3.placeholder;

      return _react2["default"].createElement(
        Field,
        { label: label, required: required,
          type: schema.type },
        _react2["default"].createElement("input", { type: "text",
          value: defaultFieldValue(formData, schema),
          placeholder: placeholder,
          required: required,
          onChange: this.onChange.bind(this) })
      );
    }
  }]);

  return TextField;
})(_react2["default"].Component);

var CheckboxField = (function (_React$Component3) {
  _inherits(CheckboxField, _React$Component3);

  function CheckboxField() {
    _classCallCheck(this, CheckboxField);

    _get(Object.getPrototypeOf(CheckboxField.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(CheckboxField, [{
    key: "onChange",
    value: function onChange(event) {
      this.props.onChange(event.target.checked);
    }
  }, {
    key: "render",
    value: function render() {
      var _props4 = this.props;
      var schema = _props4.schema;
      var formData = _props4.formData;
      var label = _props4.label;
      var required = _props4.required;
      var placeholder = _props4.placeholder;

      return _react2["default"].createElement(
        Field,
        { label: label, required: required,
          type: schema.type },
        _react2["default"].createElement("input", { type: "checkbox",
          title: placeholder,
          checked: defaultFieldValue(formData, schema),
          required: required,
          onChange: this.onChange.bind(this) })
      );
    }
  }]);

  return CheckboxField;
})(_react2["default"].Component);

var SelectField = (function (_React$Component4) {
  _inherits(SelectField, _React$Component4);

  function SelectField() {
    _classCallCheck(this, SelectField);

    _get(Object.getPrototypeOf(SelectField.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(SelectField, [{
    key: "onChange",
    value: function onChange(event) {
      this.props.onChange(event.target.value);
    }
  }, {
    key: "render",
    value: function render() {
      var _props5 = this.props;
      var schema = _props5.schema;
      var formData = _props5.formData;
      var options = _props5.options;
      var required = _props5.required;
      var label = _props5.label;

      return _react2["default"].createElement(
        Field,
        { label: label, required: required },
        _react2["default"].createElement(
          "select",
          { value: defaultFieldValue(formData, schema),
            title: schema.description,
            onChange: this.onChange.bind(this) },
          options.map(function (option, i) {
            return _react2["default"].createElement(
              "option",
              { key: i },
              option
            );
          })
        )
      );
    }
  }]);

  return SelectField;
})(_react2["default"].Component);

var UnsupportedField = (function (_React$Component5) {
  _inherits(UnsupportedField, _React$Component5);

  function UnsupportedField() {
    _classCallCheck(this, UnsupportedField);

    _get(Object.getPrototypeOf(UnsupportedField.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(UnsupportedField, [{
    key: "render",
    value: function render() {
      // XXX render json as string so dev can inspect faulty subschema
      return _react2["default"].createElement(
        "div",
        { className: "unsupported-field" },
        "Unsupported field schema ",
        JSON.stringify(this.props.schema),
        "."
      );
    }
  }]);

  return UnsupportedField;
})(_react2["default"].Component);

var SchemaField = (function (_React$Component6) {
  _inherits(SchemaField, _React$Component6);

  function SchemaField() {
    _classCallCheck(this, SchemaField);

    _get(Object.getPrototypeOf(SchemaField.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(SchemaField, [{
    key: "render",
    value: function render() {
      var schema = this.props.schema;

      var FieldComponent = SchemaField.fieldComponents[schema.type] || UnsupportedField;
      return _react2["default"].createElement(FieldComponent, this.props);
    }
  }], [{
    key: "fieldComponents",
    get: function get() {
      return {
        string: StringField,
        array: ArrayField,
        boolean: BooleanField,
        object: ObjectField,
        "date-time": StringField,
        number: StringField
      };
    }
  }]);

  return SchemaField;
})(_react2["default"].Component);

var StringField = (function (_React$Component7) {
  _inherits(StringField, _React$Component7);

  function StringField() {
    _classCallCheck(this, StringField);

    _get(Object.getPrototypeOf(StringField.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(StringField, [{
    key: "render",
    value: function render() {
      var _props6 = this.props;
      var schema = _props6.schema;
      var formData = _props6.formData;
      var required = _props6.required;
      var onChange = _props6.onChange;

      var commonProps = {
        schema: schema,
        label: schema.title,
        formData: formData,
        required: required,
        onChange: onChange.bind(this)
      };
      if (Array.isArray(schema["enum"])) {
        return _react2["default"].createElement(SelectField, _extends({ options: schema["enum"] }, commonProps));
      }
      return _react2["default"].createElement(TextField, _extends({ placeholder: schema.description }, commonProps));
    }
  }]);

  return StringField;
})(_react2["default"].Component);

var BooleanField = (function (_React$Component8) {
  _inherits(BooleanField, _React$Component8);

  function BooleanField() {
    _classCallCheck(this, BooleanField);

    _get(Object.getPrototypeOf(BooleanField.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(BooleanField, [{
    key: "render",
    value: function render() {
      var _props7 = this.props;
      var schema = _props7.schema;
      var formData = _props7.formData;
      var required = _props7.required;
      var onChange = _props7.onChange;

      var commonProps = {
        schema: schema,
        label: schema.title,
        formData: formData,
        required: required,
        onChange: onChange.bind(this)
      };
      return _react2["default"].createElement(CheckboxField, _extends({ placeholder: schema.description }, commonProps));
    }
  }]);

  return BooleanField;
})(_react2["default"].Component);

var ArrayField = (function (_React$Component9) {
  _inherits(ArrayField, _React$Component9);

  function ArrayField(props) {
    _classCallCheck(this, ArrayField);

    _get(Object.getPrototypeOf(ArrayField.prototype), "constructor", this).call(this, props);
    var formData = Array.isArray(props.formData) ? props.formData : null;
    this.state = { items: formData || props.schema["default"] || [] };
  }

  _createClass(ArrayField, [{
    key: "defaultItem",
    value: function defaultItem(itemsSchema) {
      if (itemsSchema["default"]) {
        return itemsSchema["default"];
      }
      return defaultTypeValue(itemsSchema.type);
    }
  }, {
    key: "isItemRequired",
    value: function isItemRequired(itemsSchema) {
      return itemsSchema.type === "string" && itemsSchema.minLength > 0;
    }
  }, {
    key: "asyncSetState",
    value: function asyncSetState(state) {
      var _this = this;

      // ensure state is propagated to parent component when it's actually set
      this.setState(state, function (_) {
        return _this.props.onChange(_this.state.items);
      });
    }
  }, {
    key: "onAddClick",
    value: function onAddClick(event) {
      event.preventDefault();
      this.setState({
        items: this.state.items.concat(this.defaultItem(this.props.schema.items))
      });
    }
  }, {
    key: "onDropClick",
    value: function onDropClick(index, event) {
      event.preventDefault();
      this.setState({
        items: this.state.items.filter(function (_, i) {
          return i !== index;
        })
      });
    }
  }, {
    key: "onChange",
    value: function onChange(index, value) {
      this.asyncSetState({
        items: this.state.items.map(function (item, i) {
          return index === i ? value : item;
        })
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var schema = this.props.schema;
      var items = this.state.items;

      return _react2["default"].createElement(
        "fieldset",
        {
          className: "field field-array field-array-of-" + schema.items.type },
        _react2["default"].createElement(
          "legend",
          null,
          schema.title
        ),
        schema.description ? _react2["default"].createElement(
          "div",
          null,
          schema.description
        ) : null,
        _react2["default"].createElement(
          "div",
          { className: "array-item-list" },
          items.map(function (item, index) {
            return _react2["default"].createElement(
              "div",
              { key: index },
              _react2["default"].createElement(SchemaField, { schema: schema.items,
                formData: items[index],
                required: _this2.isItemRequired(schema.items),
                onChange: _this2.onChange.bind(_this2, index) }),
              _react2["default"].createElement(
                "p",
                { className: "array-item-remove" },
                _react2["default"].createElement(
                  "button",
                  { type: "button",
                    onClick: _this2.onDropClick.bind(_this2, index) },
                  "-"
                )
              )
            );
          })
        ),
        _react2["default"].createElement(
          "p",
          { className: "array-item-add" },
          _react2["default"].createElement(
            "button",
            { type: "button", onClick: this.onAddClick.bind(this) },
            "+"
          )
        )
      );
    }
  }, {
    key: "itemTitle",
    get: function get() {
      var schema = this.props.schema;

      return schema.items.title || schema.items.description || "Item";
    }
  }]);

  return ArrayField;
})(_react2["default"].Component);

var ObjectField = (function (_React$Component10) {
  _inherits(ObjectField, _React$Component10);

  function ObjectField(props) {
    _classCallCheck(this, ObjectField);

    _get(Object.getPrototypeOf(ObjectField.prototype), "constructor", this).call(this, props);
    this.state = props.formData || props.schema["default"] || {};
  }

  _createClass(ObjectField, [{
    key: "isRequired",
    value: function isRequired(name) {
      var schema = this.props.schema;
      return Array.isArray(schema.required) && schema.required.indexOf(name) !== -1;
    }
  }, {
    key: "asyncSetState",
    value: function asyncSetState(state) {
      var _this3 = this;

      // ensure state is propagated to parent component when it's actually set
      this.setState(state, function (_) {
        return _this3.props.onChange(_this3.state);
      });
    }
  }, {
    key: "onChange",
    value: function onChange(name, value) {
      this.asyncSetState(_defineProperty({}, name, value));
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var schema = this.props.schema;

      return _react2["default"].createElement(
        "fieldset",
        null,
        _react2["default"].createElement(
          "legend",
          null,
          schema.title || "Object"
        ),
        Object.keys(schema.properties).map(function (name, index) {
          return _react2["default"].createElement(SchemaField, { key: index,
            name: name,
            required: _this4.isRequired(name),
            schema: schema.properties[name],
            formData: _this4.state[name],
            onChange: _this4.onChange.bind(_this4, name) });
        })
      );
    }
  }]);

  return ObjectField;
})(_react2["default"].Component);

var ErrorList = (function (_React$Component11) {
  _inherits(ErrorList, _React$Component11);

  function ErrorList() {
    _classCallCheck(this, ErrorList);

    _get(Object.getPrototypeOf(ErrorList.prototype), "constructor", this).apply(this, arguments);
  }

  _createClass(ErrorList, [{
    key: "render",
    value: function render() {
      var errors = this.props.errors;

      if (errors.length === 0) {
        return null;
      }
      return _react2["default"].createElement(
        "div",
        { className: "errors" },
        _react2["default"].createElement(
          "h2",
          null,
          "Errors"
        ),
        _react2["default"].createElement(
          "ul",
          null,
          errors.map(function (error, i) {
            return _react2["default"].createElement(
              "li",
              { key: i },
              error.stack
            );
          })
        )
      );
    }
  }]);

  return ErrorList;
})(_react2["default"].Component);

var Form = (function (_React$Component12) {
  _inherits(Form, _React$Component12);

  function Form(props) {
    _classCallCheck(this, Form);

    _get(Object.getPrototypeOf(Form.prototype), "constructor", this).call(this, props);
    var edit = !!props.formData;
    var formData = props.formData || props.schema["default"] || null;
    this.state = {
      status: "initial",
      formData: formData,
      edit: edit,
      errors: edit ? this.validate(formData) : []
    };
  }

  _createClass(Form, [{
    key: "validate",
    value: function validate(formData) {
      var validator = new _jsonschema.Validator();
      return validator.validate(formData, this.props.schema).errors;
    }
  }, {
    key: "renderErrors",
    value: function renderErrors() {
      if (this.state.edit && this.state.status !== "editing") {
        return _react2["default"].createElement(ErrorList, { errors: this.state.errors });
      }
      return null;
    }
  }, {
    key: "onChange",
    value: function onChange(formData) {
      var _this5 = this;

      this.setState({
        status: "editing",
        formData: formData,
        errors: this.validate(formData)
      }, function (_) {
        if (_this5.props.onChange) {
          _this5.props.onChange(_this5.state);
        }
      });
    }
  }, {
    key: "onSubmit",
    value: function onSubmit(event) {
      var _this6 = this;

      event.preventDefault();
      this.setState({ status: "submitted" });
      var errors = this.validate(this.state.formData);
      if (Object.keys(errors).length > 0) {
        this.setState({ errors: errors }, function (_) {
          if (_this6.props.onError) {
            _this6.props.onError(errors);
          } else {
            console.error("Form validation failed", errors);
          }
        });
        return;
      } else if (this.props.onSubmit) {
        this.props.onSubmit(this.state);
      }
      this.setState({ status: "initial" });
    }
  }, {
    key: "render",
    value: function render() {
      var schema = this.props.schema;
      var formData = this.state.formData;

      return _react2["default"].createElement(
        "form",
        { className: "generic-form", onSubmit: this.onSubmit.bind(this) },
        this.renderErrors(),
        _react2["default"].createElement(SchemaField, {
          schema: schema,
          formData: formData,
          onChange: this.onChange.bind(this) }),
        _react2["default"].createElement(
          "p",
          null,
          _react2["default"].createElement(
            "button",
            { type: "submit" },
            "Submit"
          )
        )
      );
    }
  }]);

  return Form;
})(_react2["default"].Component);

exports["default"] = Form;
module.exports = exports["default"];